import './trinkets/trinkets.js'
import "./utils/books_functions/learn"
import './trinkets/trinketsInv.js'
import './trinkets/main.js'
import './ar_loots.js'
import './loots.js'
import './masks.js'
import './tool.js'
import './armor.js'
import './bleeding.js'
import { EquipmentSlot, world, ItemStack } from '@minecraft/server';
import { DamageItem } from "./gametests/damage_item";
import { afterEvents, Vector } from "./gametests/extras";

world.afterEvents.playerSpawn.subscribe((ev) => {
    const {player, initialSpawn} = ev;
    if(player.hasTag("tome")) return;
    player.addTag("tome");
    let bookTrinket = new ItemStack("arena:trinket_i", 1);
    bookTrinket.keepOnDeath = true;
    let inventory = player.getComponent("minecraft:inventory").container;
    inventory.addItem(bookTrinket);
    player.addTag("tome");
})

afterEvents.itemUseOn.subscribe(({ source }) => DamageItem(source, source.equippable.getEquipmentSlot(EquipmentSlot.Mainhand)));
afterEvents.playerBreakBlock.subscribe(({ player }) => DamageItem(player, player.equippable.getEquipmentSlot(EquipmentSlot.Mainhand)));