import { world, system, ItemStack } from "@minecraft/server";
import { books_data } from "../vars";

world.beforeEvents.worldInitialize.subscribe((ev) => {
    ev.itemComponentRegistry.registerCustomComponent("arena:learn", {
        onUse({ itemStack, source }) {
            if (!source || !itemStack) return;
            const bookId = itemStack.typeId;
            const bookInfo = books_data[bookId];
            if (!bookInfo) return;
            const bookTag = bookId.replace("arena:", "").split("_").join("");
            const xpComponent = source.level;
            const currentXp = xpComponent ?? 0;
            const requiredXp = bookInfo.xpCost;
            if (source.isSneaking) {
            if (currentXp < requiredXp) {
                source.sendMessage(`§4Required §f${requiredXp} Levels of Experience`);
                source.playSound("random.break");
                return;
            }
            source.addLevels(-requiredXp);
            if (!source.hasTag(bookTag)) {
                source.addTag(bookTag);
                source.playSound("smithing_table.use");
            }
            if (bookInfo.next) {
                const upgradedItem = new ItemStack(bookInfo.next, 1);
                upgradedItem.keepOnDeath = true;
                source.getComponent("minecraft:inventory")?.container.setItem(source.selectedSlotIndex, upgradedItem);
                source.sendMessage(books_data[bookInfo.next].message);
                source.playSound("smithing_table.use");
                }
            }
        }
    });
});
