import { world, system } from '@minecraft/server'

let duration = 5
let damage = 1

function bleed(hitEntity, currentHealth) {
    const intervalId = system.runInterval(() => {
        if (currentHealth - damage < 0) {
            if (currentHealth < damage) {
                hitEntity.kill()
            }
            system.clearRun(intervalId)
            return;
        }

        if (currentHealth - damage == 0) {
            hitEntity.applyDamage(damage)
            system.clearRun(intervalId)
            return;
        }

        if (hitEntity.getDynamicProperty('twm:bleedingCont') >= duration) {
            system.clearRun(intervalId)
            return;
        }

        hitEntity.applyDamage(damage)
        hitEntity.dimension.spawnParticle("arena:bleeding", hitEntity.location)
        hitEntity.setDynamicProperty('twm:bleedingCont', hitEntity.getDynamicProperty('twm:bleedingCont') + 1)
        currentHealth -= damage
    }, 20)
}

world.afterEvents.entityHitEntity.subscribe(e => {
    const { damagingEntity, hitEntity } = e
    if (damagingEntity.hasTag('arena:blood_scythe_charm') && 5 >= Math.ceil(Math.random() * 100)) {
    if (hitEntity.getDynamicProperty('twm:bleedingCont') == undefined) {
        hitEntity.setDynamicProperty('twm:bleedingCont', 0)
        let currentHealth = hitEntity.getComponent('minecraft:health').currentValue
        bleed(hitEntity, currentHealth)
    } else {
        if (hitEntity.getDynamicProperty('twm:bleedingCont') == duration) {
            hitEntity.setDynamicProperty('twm:bleedingCont', 0)
            let currentHealth = hitEntity.getComponent('minecraft:health').currentValue
            bleed(hitEntity, currentHealth)
        }
        hitEntity.setDynamicProperty('twm:bleedingCont', 0)
    }}

    if (damagingEntity.hasTag('arena:iron_bleeding_earring_amulet') && 5 >= Math.ceil(Math.random() * 100)) {
    if (hitEntity.getDynamicProperty('twm:bleedingCont') == undefined) {
        hitEntity.setDynamicProperty('twm:bleedingCont', 0)
        let currentHealth = hitEntity.getComponent('minecraft:health').currentValue
        bleed(hitEntity, currentHealth)
    } else {
        if (hitEntity.getDynamicProperty('twm:bleedingCont') == duration) {
            hitEntity.setDynamicProperty('twm:bleedingCont', 0)
            let currentHealth = hitEntity.getComponent('minecraft:health').currentValue
            bleed(hitEntity, currentHealth)
        }
        hitEntity.setDynamicProperty('twm:bleedingCont', 0)
    }}


    if (damagingEntity.hasTag('arena:golden_bleeding_earring_amulet') && 10 >= Math.ceil(Math.random() * 100)) {
    if (hitEntity.getDynamicProperty('twm:bleedingCont') == undefined) {
        hitEntity.setDynamicProperty('twm:bleedingCont', 0)
        let currentHealth = hitEntity.getComponent('minecraft:health').currentValue
        bleed(hitEntity, currentHealth)
    } else {
        if (hitEntity.getDynamicProperty('twm:bleedingCont') == duration) {
            hitEntity.setDynamicProperty('twm:bleedingCont', 0)
            let currentHealth = hitEntity.getComponent('minecraft:health').currentValue
            bleed(hitEntity, currentHealth)
        }
        hitEntity.setDynamicProperty('twm:bleedingCont', 0)
    }}

    if (damagingEntity.hasTag('arena:prismarine_bleeding_earring_amulet') && 15 >= Math.ceil(Math.random() * 100)) {
    if (hitEntity.getDynamicProperty('twm:bleedingCont') == undefined) {
        hitEntity.setDynamicProperty('twm:bleedingCont', 0)
        let currentHealth = hitEntity.getComponent('minecraft:health').currentValue
        bleed(hitEntity, currentHealth)
    } else {
        if (hitEntity.getDynamicProperty('twm:bleedingCont') == duration) {
            hitEntity.setDynamicProperty('twm:bleedingCont', 0)
            let currentHealth = hitEntity.getComponent('minecraft:health').currentValue
            bleed(hitEntity, currentHealth)
        }
        hitEntity.setDynamicProperty('twm:bleedingCont', 0)
    }}

    if (damagingEntity.hasTag('arena:netherite_bleeding_earring_amulet') && 20 >= Math.ceil(Math.random() * 100)) {
    if (hitEntity.getDynamicProperty('twm:bleedingCont') == undefined) {
        hitEntity.setDynamicProperty('twm:bleedingCont', 0)
        let currentHealth = hitEntity.getComponent('minecraft:health').currentValue
        bleed(hitEntity, currentHealth)
    } else {
        if (hitEntity.getDynamicProperty('twm:bleedingCont') == duration) {
            hitEntity.setDynamicProperty('twm:bleedingCont', 0)
            let currentHealth = hitEntity.getComponent('minecraft:health').currentValue
            bleed(hitEntity, currentHealth)
        }
        hitEntity.setDynamicProperty('twm:bleedingCont', 0)
    }}
})