import { world, system, ItemStack } from '@minecraft/server'

system.runInterval(() => {
    let players = world.getAllPlayers();
    players.forEach(player => {
    if (player.hasTag('arena:ethereal_sight_mask_head')) {
    player.runCommand("execute as @s at @s in the_end if entity @s [r=1] if entity @s[x=~,y=-17,z=~,r=23] run function fall");
     }

    if (!player.hasTag('scroll')) {
    player.runCommand("give @s twm:scroll");
    player.addTag('scroll');
     }
 })
}, 120);

world.afterEvents.itemCompleteUse.subscribe(e => {
    let item = e.itemStack
    let food = item.getComponent('food')
    let player = e.source 
    //world.sendMessage(`${JSON.stringify(food)}`) 
        if (player.hasTag('arena:onion_ring_ring') && food != undefined) {
            player.addEffect('haste', 20 * 6 * food.nutrition, { amplifier: 1, showParticles: false })
        }

});

world.afterEvents.itemUse.subscribe( async(data) => {
  let player = data.source;
  let equip = player.getComponent('equippable');
  let item = data.itemStack; {

 if (item.typeId == "arena:scroll"){   
    player.runCommand('function empty');
    }

if (item.typeId == 'minecraft:ender_pearl') {
    const equippable = player.getComponent('equippable')

    if (player.hasTag('arena:warp_drive_talisman')) {
        //world.sendMessage('when enderpearl')
        let enderPearl = equippable.getEquipment('Mainhand')
        if (enderPearl) {
            enderPearl.amount += 1
            equippable.setEquipment('Mainhand', enderPearl)
        } else {
            equippable.setEquipment('Mainhand', new ItemStack('minecraft:ender_pearl'))
        }}
    }
}
});

world.afterEvents.worldInitialize.subscribe(() => {
    system.runInterval(() => {
        let start = Date.now()
        // We obtain all the players 
        let players = world.getAllPlayers()
        players.forEach(player => {

            // We obtain both blocks where the player is
            const feetBlock = player.dimension?.getBlock(player.location);
            const headBlock = player.dimension?.getBlock(player.location)?.above(1);

            const mainhand = player.getComponent('minecraft:equippable').getEquipment('Mainhand')
            const id = mainhand?.typeId
            const amount = mainhand?.amount
            
                        if (player.hasTag('arena:zultinus_doll_doll')) {
                player.runCommandAsync('effect @a[r=7] haste 10 1')
            }
            let entities = player.dimension.getEntities({ location: player.location, minDistance: 1, maxDistance: 5 })
            entities.forEach(entity => {
                if (entity?.hasComponent('minecraft:is_tamed')) {
                    if (player.hasTag('arena:iron_crown_jelewer_head')) {
                        entity.addEffect('regeneration', 100, { amplifier: 0, showParticles: true });
                    }
                    if (player.hasTag('arena:golden_crown_jelewer_head')) {
                        entity.addEffect('regeneration', 100, { amplifier: 1, showParticles: true });
                    }
                    if (player.hasTag('arena:prismarine_crown_jelewer_head')) {
                        entity.addEffect('regeneration', 100, { amplifier: 2, showParticles: true });
                    }
                    if (player.hasTag('arena:netherite_crown_jelewer_head')) {
                        entity.addEffect('regeneration', 100, { amplifier: 3, showParticles: true });
                    }
                }
                if (entity?.hasComponent('minecraft:rideable') && !entity?.matches({ families: [ "monster" ]})) {
                    if (player.hasTag('arena:cowboy_hat_head')) {
                        entity.addEffect('speed', 100, { amplifier: 1, showParticles: false });
                    }
                }
                if (!entity?.hasComponent('minecraft:is_tamed')) {
                    if (player.hasTag('arena:flame_pendant_necklace')) {
                        entity.setOnFire(3);
                    }
                    if (player.hasTag('arena:demon_mask_head') && player.hasTag('mask9_ready')) {
                        entity.setOnFire(3);
                    }
                }
                    if (entity?.matches({ families: [ "monster" ]})) {
                    if (player.hasTag('arena:systemtv_doll_doll')) {
                        entity.addEffect('weakness', 100, { amplifier: 1, showParticles: true });
                    }
                    if (player.getComponent('equippable').getEquipment('Chest')?.typeId == 'arena:marble_chestplate') {
                        entity.addEffect('weakness', 100, { amplifier: 4, showParticles: true });
                    }
                }
                    if (entity?.matches({ families: [ "irongolem" ]})) {
                    if (player.hasTag('arena:netherite_rune_charm_charm')) {
                        entity.addEffect('strength', 200, { amplifier: 3, showParticles: true });
                        entity.addEffect('resistance', 200, { amplifier: 2, showParticles: true });
                    }
                }
                if (!entity?.matches({ families: [ "monster" ]})) {
                    if (player.getComponent('equippable').getEquipment('Chest')?.typeId == 'arena:marble_chestplate') {
                        entity.addEffect('resistance', 100, { amplifier: 0, showParticles: true });
                        entity.addEffect('regeneration', 100, { amplifier: 1, showParticles: true });
                    }
                }
                if (entity?.matches({ families: [ "monster" ]})) {
                    if (player.hasTag('arena:marble_rune_charm_charm')) {
                        player.addEffect('slowness', 200, { amplifier: 1, showParticles: true });
                    }
                }
            })
        });
        // world.sendMessage(`${Date.now() - start}`)
    }, 60)
})

world.afterEvents.worldInitialize.subscribe(() => {
    system.runInterval(() => {
        // We obtain all the players 
        let players = world.getAllPlayers()
        players.forEach(player => {

            if (player.hasTag('arena:archaic_marble_wings_archaiccharm')) {
        let jumps = player.getDynamicProperty('arena:jumps') || 0
        const maxExtraJumps = 3
        if (player.isFalling && jumps < maxExtraJumps) {
          if (player.isJumping) {
            let { x, y, z } = player.getVelocity()
            player.applyKnockback(x, z, Math.SQRT2 * Math.sqrt(x * x + z * z), 1.25)
            jumps += 1
          }
        }
        if (player.isOnGround) {
          jumps = 0
        }
        player.setDynamicProperty('arena:jumps', jumps)
      }
       if (player.hasTag('arena:fox_mask_head')) {
        let jumps = player.getDynamicProperty('arena:jumps_fox') || 0
        const maxExtraJumps = 1
        if (player.isFalling && jumps < maxExtraJumps) {
          if (player.isJumping) {
            let { x, y, z } = player.getVelocity()
            player.applyKnockback(x, z, 4.5 * Math.sqrt(x * x + z * z), 0.65)
            jumps += 1
          }
        }
        if (player.isOnGround) {
          jumps = 0
        }
        player.setDynamicProperty('arena:jumps_fox', jumps)
      }

            if (player.hasTag('arena:cloud_in_a_bottle_talisman')) {
                let jumps = player.getDynamicProperty('arena:cloud') || 0
                const maxExtraJumps = 1
                if (player.isFalling && jumps < maxExtraJumps) {
                    if (player.isJumping) {
                        let { x, y, z } = player.getVelocity()
                        player.applyKnockback(x, z, Math.SQRT2 * Math.sqrt(x * x + z * z), 0.65)
                        jumps += 1
                    }
                }
                if (player.isOnGround) {
                    jumps = 0
                }
                player.setDynamicProperty('arena:cloud', jumps)
            }
        });
    }, 1)
    system.runInterval(() => {
        // We obtain all the players 
        let players = world.getAllPlayers()
        players.forEach(player => { //
            if (player.hasTag('arena:demon_mask_head') && !player.hasTag('mask9_cooldown') && !player.hasTag('mask9_ready')) {
                player.triggerEvent('minecraft:mask9_timer_on')
                player.addTag('mask9_cooldown')
            }
            if (player.hasTag('arena:demon_mask_head') && player.hasTag('mask9_ready')) {
                player.runCommandAsync('function mask9')
            } 
            if (player.hasTag('arena:magnet_talisman_talisman')) {
                player.runCommandAsync('execute at @e[type=item, r=12.5] run tp @e[type=item, r=12.5] ^^^+0.5 facing @s')
            }
            if (player.hasTag('arena:cat_mask_head')) {
                player.triggerEvent('minecraft:light_level')
            }
            if (player.hasTag('arena:spectral_talisman_talisman') && !player.hasTag('arena:cat_mask_head')) {
                player.triggerEvent('minecraft:light_level')
            }
        });
    }, 5)
})

world.afterEvents.worldInitialize.subscribe(() => {
    system.runInterval(() => {
        // We obtain all the players 
        let players = world.getAllPlayers()
        players.forEach(player => {
            if (player.hasTag('arena:archaic_cursed_book_archaiccharm') && player.hasTag('mask9_ready')) {
                player.runCommandAsync('xp -1l @s')
            } 
            if (player.hasTag('arena:archaic_marble_wings_archaiccharm')) {
                player.runCommandAsync('event entity @e[r=25,type=zombie_villager] villager_converted')
            }
            if (player.hasTag('arena:rooted_boots_feet')) {
                player.runCommand("execute at @s as @s if block ~~-1~ grass_block run effect @s saturation 1 0");
            }
        });
    }, 1200)
})


world.afterEvents.entityDie.subscribe((e) => {
    const { deadEntity, damageSource } = e
    let attacker = damageSource.damagingEntity
    const typea = [
        "minecraft:drowned",
        "minecraft:husk",
        "minecraft:zombie",
        "minecraft:zombie_pigman",
        "minecraft:zombie_villager"
    ];
    const typeb = [
        "minecraft:agent",
        "minecraft:allay",
        "minecraft:bat",
        "minecraft:iron_golem",
        "minecraft:npc",
        "minecraft:player",
        "minecraft:snow_golem",
        "minecraft:tadpole",
        "minecraft:villager",
        "minecraft:wandering_trader"
    ];
    const typec = [
        "minecraft:blaze",
        "minecraft:elder_guardian",
        "minecraft:evocation_illager",
        "minecraft:guardian",
        "minecraft:enderman"
    ];
    const typed = [
        "minecraft:piglin_brute",
        "minecraft:ravager"
    ];
    if (attacker?.typeId == 'minecraft:player') {
        if (attacker.hasTag('arena:archaic_arnold_archaiccharm')) {
            if (!deadEntity.hasComponent('minecraft:is_baby') && !typea.includes(deadEntity.typeId) && !typeb.includes(deadEntity.typeId) && !typec.includes(deadEntity.typeId) && !typed.includes(deadEntity.typeId) && deadEntity.typeId != "minecraft:ender_dragon" && deadEntity.typeId != "minecraft:wither") {
                attacker.runCommand("xp 5 @s");
            } else if ((deadEntity.hasComponent('minecraft:is_baby') && typea.includes(deadEntity.typeId)) || typec.includes(deadEntity.typeId)) {
                attacker.runCommand("xp 10 @s");
            } else if (typed.includes(deadEntity.typeId)) {
                attacker.runCommand("xp 200 @s");
            } else if (deadEntity.typeId == "minecraft:wither") {
                attacker.runCommand("xp 500 @s");
            } else if (deadEntity.typeId == "minecraft:ender_dragon") {
                attacker.runCommand("xp 500 @s");
            }
        }
        
        if (attacker.hasTag('arena:golden_hook_gauntlet')) {
            if (!deadEntity.hasComponent('minecraft:is_baby') && !typea.includes(deadEntity.typeId) && !typeb.includes(deadEntity.typeId) && !typec.includes(deadEntity.typeId) && !typed.includes(deadEntity.typeId) && deadEntity.typeId != "minecraft:ender_dragon" && deadEntity.typeId != "minecraft:wither") {
                attacker.runCommand("xp 2 @s");
            } else if ((deadEntity.hasComponent('minecraft:is_baby') && typea.includes(deadEntity.typeId)) || typec.includes(deadEntity.typeId)) {
                attacker.runCommand("xp 5 @s");
            } else if (typed.includes(deadEntity.typeId)) {
                attacker.runCommand("xp 100 @s");
            } else if (deadEntity.typeId == "minecraft:wither") {
                attacker.runCommand("xp 250 @s");
            } else if (deadEntity.typeId == "minecraft:ender_dragon") {
                attacker.runCommand("xp 250 @s");
            }
        }
        if (attacker.hasTag('arena:doble_edged_charm')) {
            let kills = attacker.getDynamicProperty('doble_edged_kills')
            if (kills) {
                kills += 1
                attacker.setDynamicProperty('doble_edged_kills', kills)
            } else {
                attacker.setDynamicProperty('doble_edged_kills', 1)
            }
        }

        if (attacker.hasTag('arena:archaic_triple_edged_sword_archaiccharm')) {
            let kills = attacker.getDynamicProperty('triple_edged_kills')
            if (kills) {
                kills += 1
                attacker.setDynamicProperty('triple_edged_kills', kills)
            } else {
                attacker.setDynamicProperty('triple_edged_kills', 1)
            }
        }

        if (attacker.hasTag('arena:nefrite_edged_sword_talisman_talisman')) {
            let kills = attacker.getDynamicProperty('edged_kills')
            if (kills) {
                kills += 1
                attacker.setDynamicProperty('edged_kills', kills)
            } else {
                attacker.setDynamicProperty('edged_kills', 1)
            }
        }
        if (attacker.hasTag('arena:wither_mask_head')) {
            attacker.runCommand("playsound mob.wither.ambient @a[r=7]")
        }
        if (attacker.hasTag('arena:marble_skull_charm_charm')) {
            attacker.addEffect('levitation', 100, { amplifier: 0, showParticles: true });
            attacker.runCommand("execute as @e[family=monster,r=2] at @s run tp @s ~~-2~")
        }
        if (attacker.hasTag('arena:blossom_crown_head')) {
            attacker.runCommand("execute as @e[family=!monster,r=4] at @s run effect @s regeneration 7 0")
        }
        if (attacker.hasTag('arena:archaic_sacret_skull_archaiccharm')) {
            attacker.addEffect('darkness', 200, { amplifier: 0, showParticles: true });
            attacker.addTag('skull_kill')
            attacker.runCommand("particle minecraft:soul_particle ~~+0.2~")
        }
        if (attacker.hasTag('arena:cherry_blossom_charm')) {
    let TimeKills = attacker.getDynamicProperty('arena:cherry_blossom_charm')
    if (TimeKills == undefined) {
        attacker.setDynamicProperty('arena:cherry_blossom_charm', 0)
        TimeKills = 0
    }
    TimeKills++
    attacker.setDynamicProperty('arena:cherry_blossom_charm', TimeKills)
    system.runTimeout(() => {
        let newTimeKills = attacker.getDynamicProperty('arena:cherry_blossom_charm')
        if (newTimeKills == TimeKills) {
            attacker.setDynamicProperty('arena:cherry_blossom_charm', 0)
        }
    }, 400)
}
}
})

world.afterEvents.entityHurt.subscribe(e => {
    const { hurtEntity, damageSource, damage } = e
    const chance = 1.0;
    const undead = [
        "minecraft:bogged",
        "minecraft:drowned",
        "minecraft:husk",
        "minecraft:phantom",
        "minecraft:skeleton",
        "minecraft:skeleton_horse",
        "minecraft:stray",
        "minecraft:wither_skeleton",
        "minecraft:zoglin",
        "minecraft:zombie",
        "minecraft:zombie_horse",
        "minecraft:zombie_pigman",
        "minecraft:zombie_villager"
    ];
    const guardians = [
        "minecraft:elder_guardian",
        "minecraft:guardian"
    ];
    const bosses = [ 
        "minecraft:ender_dragon",
        "minecraft:wither",
        "minecraft:warden",
        "minecraft:elder_guardian",
        "minecraft:piglin_brute",
        "minecraft:ravager"
    ];
    const health = hurtEntity.getComponent('minecraft:health').currentValue;
    let cancel_hit = false;
    let attacker = damageSource.damagingEntity
    if (attacker?.typeId == 'minecraft:player') {
        // Effects list
        // effect: is the name of the effect
        // condition: if it needs an external condition or even having another tag (for doing sets)
        // If the trinket doesnt need any conditions, write 1 or True
        // level: the level of the given effect

        // Tag = item identifier + slot
        const activeEffects = {
            'arena:handwarmer_gauntlet': [
                { effect: 'slowness', level: 1, condition: damageSource.cause != 'projectile', effectTime: 120 }
            ],
            'arena:natural_butterfly_mask_head': [
                { effect: 'wither', level: 4, condition: 1, effectTime: 120 }
            ],
            'arena:amethyst_earring_jelewer_ring': [
                { effect: 'slowness', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:crimsom_earring_jelewer_ring': [
                { effect: 'poison', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:crimsom_amethyst_earring_jelewer_ring': [
                { effect: 'weakness', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:iron_end_necklace_jelewer_necklace': [
                { effect: 'levitation', level: 1, condition: 1, effectTime: 3 }
            ],
            'arena:iron_fire_necklace_jelewer_necklace': [
                { effect: 'weakness', level: 2, condition: 1, effectTime: 180 }
            ],
            'arena:iron_poison_necklace_jelewer_necklace': [
                { effect: 'poison', level: 2, condition: 1, effectTime: 180 }
            ],
            'arena:iron_snow_necklace_jelewer_necklace': [
                { effect: 'slowness', level: 2, condition: 1, effectTime: 180 }
            ],
            'arena:golden_end_necklace_jelewer_necklace': [
                { effect: 'levitation', level: 2, condition: 1, effectTime: 120 }
            ],
            'arena:golden_fire_necklace_jelewer_necklace': [
                { effect: 'weakness', level: 3, condition: 1, effectTime: 240 }
            ],
            'arena:golden_poison_necklace_jelewer_necklace': [
                { effect: 'poison', level: 3, condition: 1, effectTime: 240 }
            ],
            'arena:golden_snow_necklace_jelewer_necklace': [
                { effect: 'slowness', level: 3, condition: 1, effectTime: 240 }
            ],
            'arena:prismarine_end_necklace_jelewer_necklace': [
                { effect: 'levitation', level: 3, condition: 1, effectTime: 150 }
            ],
            'arena:prismarine_fire_necklace_jelewer_necklace': [
                { effect: 'weakness', level: 4, condition: 1, effectTime: 300 }
            ],
            'arena:prismarine_poison_necklace_jelewer_necklace': [
                { effect: 'poison', level: 4, condition: 1, effectTime: 300 }
            ],
            'arena:prismarine_snow_necklace_jelewer_necklace': [
                { effect: 'slowness', level: 4, condition: 1, effectTime: 300 }
            ],
            'arena:netherite_end_necklace_jelewer_necklace': [
                { effect: 'levitation', level: 4, condition: 1, effectTime: 150 }
            ],
            'arena:netherite_fire_necklace_jelewer_necklace': [
                { effect: 'weakness', level: 5, condition: 1, effectTime: 360 }
            ],
            'arena:netherite_poison_necklace_jelewer_necklace': [
                { effect: 'poison', level: 5, condition: 1, effectTime: 360 }
            ],
            'arena:netherite_snow_necklace_jelewer_necklace': [
                { effect: 'slowness', level: 5, condition: 1, effectTime: 360 }
            ],
            'arena:archaic_chained_soul_archaiccharm': [
                { effect: 'wither', level: 1, condition: attacker.getComponent('minecraft:health').currentValue <= 6, effectTime: 120 }
            ], 
            'arena:archaic_soul_hand_archaiccharm': [
                { effect: 'wither', level: 1, condition: attacker.getComponent('minecraft:health').currentValue <= 5, effectTime: 120 },
                { effect: 'poison', level: 1, condition: attacker.getComponent('minecraft:health').currentValue <= 5, effectTime: 120 }
            ], 
        };
        // Estos hacen cosas diferentes a efectos 
        if (attacker.hasTag('arena:blaze_skull_mask_head') && damageSource.cause != 'projectile') {
            hurtEntity.setOnFire(10)
        }
        if (attacker.hasTag('arena:fire_gauntlet_gauntlet') && damageSource.cause != 'projectile') {
            hurtEntity.setOnFire(3)
        }
        if (attacker.hasTag('arena:demon_mask_head') && attacker.hasTag('mask9_ready')) {
            hurtEntity.applyDamage(damage * 2)
            attacker.removeTag('mask9_ready')
        }
        if (attacker.hasTag('arena:iron_fire_necklace_jelewer_necklace')) {
            hurtEntity.setOnFire(3)
            if (2 >= Math.ceil(Math.random() * 100)) {
                hurtEntity.applyDamage(damage * 0.5)
            }
        }
        if (attacker.hasTag('arena:archaic_soul_hand_archaiccharm')) {
            hurtEntity.applyDamage(health*0.15)
        }
        if (attacker.hasTag('arena:iron_end_necklace_jelewer_necklace') && 4 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:iron_light_necklace_jelewer_necklace') && 8 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:iron_snow_necklace_jelewer_necklace') && 4 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:golden_fire_necklace_jelewer_necklace')) {
            hurtEntity.setOnFire(4)
            if (4 >= Math.ceil(Math.random() * 100)) {
                hurtEntity.applyDamage(damage * 0.5)
            }
        }
        if (attacker.hasTag('arena:golden_end_necklace_jelewer_necklace') && 8 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:golden_light_necklace_jelewer_necklace') && 16 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:golden_snow_necklace_jelewer_necklace') && 8 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:prismarine_fire_necklace_jelewer_necklace')) {
            hurtEntity.setOnFire(5)
            if (6 >= Math.ceil(Math.random() * 100)) {
                hurtEntity.applyDamage(damage * 0.5)
            }
        }
        if (attacker.hasTag('arena:prismarine_end_necklace_jelewer_necklace') && 12 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:prismarine_light_necklace_jelewer_necklace') && 24 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:prismarine_snow_necklace_jelewer_necklace') && 16 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:netherite_fire_necklace_jelewer_necklace')) {
            hurtEntity.setOnFire(6)
            if (8 >= Math.ceil(Math.random() * 100)) {
                hurtEntity.applyDamage(damage * 0.5)
            }
        }
        if (attacker.hasTag('arena:netherite_end_necklace_jelewer_necklace') && 16 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:netherite_light_necklace_jelewer_necklace') && 32 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:netherite_snow_necklace_jelewer_necklace') && 16 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:archaic_marble_wings_archaiccharm') && hurtEntity.matches({ families: [ "undead" ]}) && attacker.getComponent('equippable').getEquipment('Chest')?.typeId == 'minecraft:elytra') {
            hurtEntity.applyDamage(damage * 0.5)
        }
        if (attacker.hasTag('arena:archaic_warden_claws_archaiccharm') && hurtEntity.matches({ families: [ "monster" ]})) {
            hurtEntity.applyDamage(damage * 0.35)
            hurtEntity.dimension.spawnParticle("minecraft:sonic_explosion", hurtEntity.location);
            hurtEntity.runCommand('execute as @s at @s run summon arena:ignited_explosion ~ ~ ~');
            attacker.runCommand("playsound shriek.sculk_shrieker @a[r=7]")
        }
        if (attacker.hasTag('arena:sacret_sword_charm')) {
            hurtEntity.applyDamage(damage * 0.25)
            hurtEntity.setOnFire(6)
        }
         if (attacker.getComponent('equippable').getEquipment('Chest')?.typeId == 'arena:marble_chestplate' && hurtEntity.matches({ families: [ "monster" ]})) {
            hurtEntity.applyDamage(damage * 0.75)
        }
        if (attacker.hasTag('arena:archaic_incript_paper_archaiccharm') && 25 >= Math.ceil(Math.random() * 100)) {
            attacker.addEffect('absorption', 120, { amplifier: 0, showParticles: false });
        }
        if (attacker.hasTag('arena:withered_bracelet_gauntlet') && 25 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.addEffect('wither', 120, { amplifier: 0, showParticles: false });
        }
        if (attacker.hasTag('arena:archaic_light_cepter_archaiccharm') && 5 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 1.5)
        }
        if (attacker.hasTag('arena:archaic_light_cepter_archaiccharm') && 35 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.runCommand('execute as @s at @s run summon lightning_bolt ~ ~ ~');
        }
        if (attacker.hasTag('arena:light_necklace_necklace') && 10 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.runCommand('execute as @s at @s run summon lightning_bolt ~ ~ ~');
        } 
        if (attacker.hasTag('arena:iron_light_necklace_jelewer_necklace') && 3 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.runCommand('execute as @s at @s run summon lightning_bolt ~ ~ ~');
        } 
        if (attacker.hasTag('arena:golden_light_necklace_jelewer_necklace') && 6 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.runCommand('execute as @s at @s run summon lightning_bolt ~ ~ ~');
        } 
        if (attacker.hasTag('arena:prismarine_light_necklace_jelewer_necklace') && 9 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.runCommand('execute as @s at @s run summon lightning_bolt ~ ~ ~');
        } 
        if (attacker.hasTag('arena:netherite_light_necklace_jelewer_necklace') && 12 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.runCommand('execute as @s at @s run summon lightning_bolt ~ ~ ~');
        } 
        if (attacker.hasTag('arena:blessed_skull_charm_charm') && 15 >= Math.ceil(Math.random() * 100)) {
            let health = attacker.getComponent('minecraft:health').currentValue
            attacker.getComponent('minecraft:health').setCurrentValue(health + damage * 0.36)
        }
        if (attacker.hasTag('arena:vampic_glove_gauntlet') && 10 >= Math.ceil(Math.random() * 100)) {
        let health = attacker.getComponent('minecraft:health').currentValue
            attacker.getComponent('minecraft:health').setCurrentValue(health + damage * 0.12)
        } 
        if (attacker.hasTag('arena:blood_scythe_charm')) {
        let health = attacker.getComponent('minecraft:health').currentValue
            attacker.getComponent('minecraft:health').setCurrentValue(health + damage * 0.05)
        } 
        if (attacker.hasTag('arena:extreme_had_head')) {
        let health = attacker.getComponent('minecraft:health').currentValue
            attacker.getComponent('minecraft:health').setCurrentValue(health + damage * 0.05)
        } 
        if (attacker.getComponent('equippable').getEquipment('Chest')?.typeId == 'arena:extreme_chestplate' && 20 >= Math.ceil(Math.random() * 100)) {
        let health = attacker.getComponent('minecraft:health').currentValue
            attacker.getComponent('minecraft:health').setCurrentValue(health + damage * 0.25)
            hurtEntity.runCommand("particle minecraft:soul_particle ~~+0.2~")
        }
        if (attacker.hasTag('skull_kill')) {
            hurtEntity.removeTag('skull_kill');
        } 
        if (attacker.hasTag('skull_kill') && 20 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.applyDamage(damage * 1)
        } 
        if (attacker.hasTag('arena:diamond_necklace_necklace') && damageSource.cause != 'projectile') {
        let hurtEntities  = hurtEntity.dimension.getEntities({ location: hurtEntity.location, minDistance: 0, maxDistance: 2 })
        hurtEntities.forEach(hurtEntity =>{hurtEntity.applyDamage(damage * 0.25)})
        }
        if (attacker.hasTag('arena:poseidon_mask_head')) {
            if (guardians.includes(hurtEntity?.typeId)) {
                hurtEntity.applyDamage(damage * 0.8)
            }
        }
        if (attacker.hasTag('arena:archaic_good_and_evil_flower_archaiccharm')) {
            if (bosses.includes(hurtEntity?.typeId)) {
                hurtEntity.applyDamage(damage * 0.8)
            }
        }
        if (attacker.hasTag('arena:iron_penetration_earring_amulet')) {
            hurtEntity.applyDamage(health*0.4)
        } 
        if (attacker.hasTag('arena:golden_penetration_earring_amulet')) {
            hurtEntity.applyDamage(health*0.8)
        } 
        if (attacker.hasTag('arena:prismarine_penetration_earring_amulet')) {
            hurtEntity.applyDamage(health*0.12)
        } 
        if (attacker.hasTag('arena:netherite_penetration_earring_amulet')) {
            hurtEntity.applyDamage(health*0.16)
        } 
        if (attacker.hasTag('arena:artemisa_deer_antler_talisman') && damageSource.cause == 'projectile') {
            hurtEntity.applyDamage(damage + 2)
        } 
        if (attacker.hasTag('arena:apolo_quiver_body') && damageSource.cause == 'projectile') {
        let hurtEntities  = hurtEntity.dimension.getEntities({ location: hurtEntity.location, minDistance: 0, maxDistance: 2 })
        hurtEntities.forEach(hurtEntity =>{hurtEntity.applyDamage(damage * 0.5)})
        } 
        if (attacker.hasTag('arena:deer_skull_talisman') && damageSource.cause == 'projectile') {
            hurtEntity.setOnFire(4)
        } 

        if (attacker.hasTag('arena:artemisa_arrowhead_charm') && damageSource.cause == 'projectile') {
            hurtEntity.runCommand('execute as @s at @s run summon arena:ignited_explosion ~ ~ ~');
        } 
        if (attacker.hasTag('arena:iron_arrows_earring_amulet') && damageSource.cause == 'projectile') {
            hurtEntity.applyDamage(damage + 1)
        } 
        if (attacker.hasTag('arena:golden_arrows_earring_amulet') && damageSource.cause == 'projectile') {
            hurtEntity.applyDamage(damage + 2)
        } 
        if (attacker.hasTag('arena:prismarine_arrows_earring_amulet') && damageSource.cause == 'projectile') {
            hurtEntity.applyDamage(damage + 3)
        } 
        if (attacker.hasTag('arena:netherite_arrows_earring_amulet') && damageSource.cause == 'projectile') {
            hurtEntity.applyDamage(damage + 4)
        } 
        if (attacker.hasTag('arena:iron_vampiric_earring_amulet')) {
        let health = attacker.getComponent('minecraft:health').currentValue
            attacker.getComponent('minecraft:health').setCurrentValue(health + damage * 0.03)
        } 
        if (attacker.hasTag('arena:golden_vampiric_earring_amulet')) {
        let health = attacker.getComponent('minecraft:health').currentValue
            attacker.getComponent('minecraft:health').setCurrentValue(health + damage * 0.06)
        } 
        if (attacker.hasTag('arena:prismarine_vampiric_earring_amulet')) {
        let health = attacker.getComponent('minecraft:health').currentValue
            attacker.getComponent('minecraft:health').setCurrentValue(health + damage * 0.09)
        } 
        if (attacker.hasTag('arena:netherite_vampiric_earring_amulet')) {
        let health = attacker.getComponent('minecraft:health').currentValue
            attacker.getComponent('minecraft:health').setCurrentValue(health + damage * 0.012)
        } 
        if (attacker.hasTag('arena:iron_explosive_earring_amulet') && 4 >= Math.ceil(Math.random() * 100) && damageSource.cause != 'projectile') {
            hurtEntity.runCommand('execute as @s at @s run summon arena:ignited_explosion ~ ~ ~');
        } 
        if (attacker.hasTag('arena:golden_explosive_earring_amulet') && 8 >= Math.ceil(Math.random() * 100) && damageSource.cause != 'projectile') {
            hurtEntity.runCommand('execute as @s at @s run summon arena:ignited_explosion ~ ~ ~');
        } 
        if (attacker.hasTag('arena:prismarine_explosive_earring_amulet') && 12 >= Math.ceil(Math.random() * 100) && damageSource.cause != 'projectile') {
            hurtEntity.runCommand('execute as @s at @s run summon arena:ignited_explosion ~ ~ ~');
        } 
        if (attacker.hasTag('arena:netherite_explosive_earring_amulet') && 16 >= Math.ceil(Math.random() * 100) && damageSource.cause != 'projectile') {
            hurtEntity.runCommand('execute as @s at @s run summon arena:ignited_explosion ~ ~ ~');
        } 
        if (attacker.hasTag('arena:artemisa_arrowhead_charm') && damageSource.cause == 'projectile') {
            hurtEntity.runCommand('execute as @s at @s run summon arena:ignited_explosion ~ ~ ~');
        } 
        if (attacker.hasTag('arena:doble_edged_charm')) {
            let kills = attacker.getDynamicProperty('doble_edged_kills')
            if (kills >= 12) {
                hurtEntity.applyDamage(damage * 0.4)
                hurtEntity.setOnFire(3)
                attacker.setDynamicProperty('doble_edged_kills', 0)
            }
        }
        if (attacker.hasTag('arena:archaic_triple_edged_sword_archaiccharm')) {
            let kills = attacker.getDynamicProperty('triple_edged_kills')
            if (kills >= 60) {
                hurtEntity.applyDamage(damage * 1)
                hurtEntity.setOnFire(3)
                attacker.setDynamicProperty('triple_edged_kills', 0)
            }
        }
        if (attacker.hasTag('arena:nefrite_edged_sword_talisman_talisman')) {
            let kills = attacker.getDynamicProperty('edged_kills')
            if (kills >= 6) {
                hurtEntity.applyDamage(damage + 5)
                attacker.setDynamicProperty('edged_kills', 0)
            }
        }
        giveEffect(attacker, activeEffects, hurtEntity)
    }
    if (hurtEntity?.typeId == 'minecraft:player') {

        // Effects list
        // effect: is the name of the effect
        // condition: if it needs an external condition or even having another tag (for doing sets)
        // If the trinket doesnt need any conditions, write 1 or True
        // level: the level of the given effect

        // Tag = item identifier + slot
        const activeEffects = {
            'arena:amethyst_earring_jelewer_ring': [
                { effect: 'slowness', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:crimsom_earring_jelewer_ring': [
                { effect: 'poison', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:crimsom_amethyst_earring_jelewer_ring': [
                { effect: 'weakness', level: 1, condition: 1, effectTime: 120 }
            ],
            'arena:unnatural_mask_head': [
                { effect: 'wither', level: 4, condition: 1, effectTime: 120 }
            ]
        } //arena:regeneration_necklace_necklace
        if (hurtEntity.hasTag('arena:blaze_skull_mask_head')) {
            attacker.setOnFire(3)
        } 
        if (hurtEntity.hasTag('arena:regeneration_necklace_necklace')) {
            hurtEntity.addEffect('speed', 120, { amplifier: 1, showParticles: false });
        }
        if (hurtEntity.hasTag('arena:crystal_heart_heartycharm')) {
            hurtEntity.applyDamage(damage * 0.25)
        } 
        if (hurtEntity.hasTag('arena:ethereal_sight_mask_head') && damageSource.cause == 'fire_tick') {
            hurtEntity.applyDamage(damage * 1)
        } 
        if (hurtEntity.hasTag('arena:archaic_marble_wings_archaiccharm') && damageSource.cause == 'fire_tick') {
            hurtEntity.applyDamage(damage * 1)
        } 
        if (hurtEntity.hasTag('arena:poseidon_mask_head') && damageSource.cause == 'fire_tick') {
            hurtEntity.applyDamage(damage * 0.5)
        } 
        if (hurtEntity.hasTag('arena:archaic_ruler_of_prismas_archaiccharm') && damageSource.cause == 'fire_tick') {
            hurtEntity.applyDamage(damage * 0.2)
        } 
        if (hurtEntity.hasTag('arena:blood_scythe_charm') && damageSource.cause == 'fire_tick') {
            hurtEntity.applyDamage(damage * 0.75)
        }
        if (hurtEntity.hasTag('arena:unnatural_mask_head') && damageSource.cause == 'magic') {
            hurtEntity.applyDamage(damage * 0.75)
        }
        if (hurtEntity.hasTag('arena:wither_mask_head') && damageSource.cause == 'magic') {
            hurtEntity.applyDamage(damage * 0.75)
        }
        if (hurtEntity.hasTag('arena:angeloso_doll_doll') && damageSource.cause == 'magic') {
            hurtEntity.applyDamage(damage * 0.25)
        }
        if (hurtEntity.hasTag('arena:demon_heart_heartycharm') && damageSource.cause == 'projectile') {
            hurtEntity.applyDamage(damage * 0.25)
        }
        if (hurtEntity.hasTag('arena:fox_mask_head') && damageSource.cause == 'projectile') {
        let health = hurtEntity.getComponent('minecraft:health').currentValue
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage * 0.5)
        }
        if (hurtEntity.hasTag('arena:vulak_doll_doll') && damageSource.cause == 'projectile') {
        let health = hurtEntity.getComponent('minecraft:health').currentValue
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage * 0.2)
        }
        if (hurtEntity.hasTag('arena:wither_mask_head') && damageSource.cause == 'projectile') {
        let health = hurtEntity.getComponent('minecraft:health').currentValue
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage * 1)
        }
        if (hurtEntity.hasTag('arena:wither_mask_head') && damageSource.cause == 'fire_tick') {
        let health = hurtEntity.getComponent('minecraft:health').currentValue
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage * 0.5)
        }
        if (hurtEntity.hasTag('arena:angelical_heart_heartycharm') && damageSource.cause == 'magic') {
        let health = hurtEntity.getComponent('minecraft:health').currentValue
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage * 0.25)
        }
        if (hurtEntity.hasTag('arena:cross_necklace_necklace') && damageSource.cause == 'magic') {
        let health = hurtEntity.getComponent('minecraft:health').currentValue
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage * 0.25)
        }
        if (hurtEntity.hasTag('arena:archaic_cursed_skull_archaiccharm') && damageSource.cause == 'magic') {
        let health = hurtEntity.getComponent('minecraft:health').currentValue
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage * 0.1)
        }
        if (hurtEntity.hasTag('arena:alaniz_doll_doll') && damageSource.cause == 'magic') {
        let health = hurtEntity.getComponent('minecraft:health').currentValue
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage * 0.25)
        }
        if (hurtEntity.getComponent('equippable').getEquipment('Chest')?.typeId == 'arena:marble_chestplate' && attacker.matches({ families: [ "monster" ]})) {
            attacker.applyDamage(damage * 0.6)
        }
        if (hurtEntity.hasTag('arena:thorn_pendant_necklace')) {
            attacker.applyDamage(damage * 0.25)
        }
        if (hurtEntity.hasTag('arena:death_skull_talisman_talisman')) {
            attacker.applyDamage(damage * 0.25)
        }
        if (hurtEntity.hasTag('arena:archaic_blessed_shield_archaiccharm') && 15 >= Math.ceil(Math.random() * 100)) {
            attacker.applyDamage(damage * 2)
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage)
        }//
        if (hurtEntity.hasTag('arena:iron_spikes_earring_amulet')) {
            attacker.applyDamage(damage * 0.08)
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage)
        }
        if (hurtEntity.hasTag('arena:golden_spikes_earring_amulet')) {
            attacker.applyDamage(damage * 0.16)
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage)
        }
        if (hurtEntity.hasTag('arena:prismarine_spikes_earring_amulet')) {
            attacker.applyDamage(damage * 0.24)
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage)
        }
        if (hurtEntity.hasTag('arena:netherite_spikes_earring_amulet')) {
            attacker.applyDamage(damage * 0.32)
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage)
        }
        if (hurtEntity.hasTag('arena:archaic_sacret_heart_archaiccharm')) {
            let health = hurtEntity.getComponent('minecraft:health').currentValue
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage * 0.2)
            attacker.applyDamage(damage * 0.2)
        } 
        if (hurtEntity.hasTag('arena:sacronkaiden_doll_doll')) {
            attacker.applyDamage(damage + 3)
        }
        if (hurtEntity.hasTag('arena:archaic_incript_paper_archaiccharm')) {
            attacker.runCommandAsync(`xp ${Math.floor(damage * 0.25)}`)
        }
        if (hurtEntity.hasTag('arena:obsidian_eye_talisman_talisman') && 25 >= Math.ceil(Math.random() * 100)) {
            hurtEntity.runCommandAsync('function evasion')
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage)
        }
        if (hurtEntity.hasTag('arena:chorus_totem_talisman')) {
            hurtEntity.runCommandAsync('function evasion')
        }
        if (hurtEntity.hasTag('arena:ethereal_sight_mask_head')) {
            hurtEntity.runCommandAsync('function mask_tp')
        }
        if (hurtEntity.hasTag('arena:ethereal_sight_mask_head') && damageSource.cause == 'projectile') {
            hurtEntity.getComponent('minecraft:health').setCurrentValue(health + damage)
        }
        giveEffect(hurtEntity, activeEffects, attacker)
    }
    if (Math.random() < 0.3*chance && hurtEntity.hasTag("skull_kill") && damageSource.damagingEntity != undefined && damageSource.damagingEntity.isValid() && damageSource.damagingProjectile == undefined) {
        let health = hurtEntity.getComponent("minecraft:health");
        health.setCurrentValue(Math.min(health.currentValue + damage, health.effectiveMax));
        damageSource.damagingEntity.applyDamage(damage, { damagingEntity: hurtEntity, cause: "magic" });
        cancel_hit = true;
    }
})

world.afterEvents.playerBreakBlock.subscribe(e => {
    const { brokenBlockPermutation, player, block } = e;

    if (!player.hasTag("arena:lucky_scarf_necklace")) return;

    const blockDrops = {
        "minecraft:coal_ore": { item: "minecraft:coal" },
        "minecraft:deepslate_coal_ore": { item: "minecraft:coal" },
        "minecraft:copper_ore": { item: "minecraft:raw_copper" },
        "minecraft:deepslate_copper_ore": { item: "minecraft:raw_copper" },
        "minecraft:iron_ore": { item: "minecraft:raw_iron" },
        "minecraft:deepslate_iron_ore": { item: "minecraft:raw_iron" },
        "minecraft:gold_ore": { item: "minecraft:raw_gold" },
        "minecraft:deepslate_gold_ore": { item: "minecraft:raw_gold" },
        "minecraft:lapis_ore": { item: "minecraft:lapis_lazuli" },
        "minecraft:deepslate_lapis_ore": { item: "minecraft:lapis_lazuli" },
        "minecraft:redstone_ore": { item: "minecraft:redstone" },
        "minecraft:lit_redstone_ore": { item: "minecraft:redstone" },
        "minecraft:deepslate_redstone_ore": { item: "minecraft:redstone" },
        "minecraft:lit_deepslate_redstone_ore": { item: "minecraft:redstone" },
        "minecraft:diamond_ore": { item: "minecraft:diamond" },
        "minecraft:deepslate_diamond_ore": { item: "minecraft:diamond" },
        "minecraft:emerald_ore": { item: "minecraft:emerald" },
        "minecraft:deepslate_emerald_ore": { item: "minecraft:emerald" },
        "minecraft:nether_gold_ore": { item: "minecraft:gold_nugget", min: 1, max: 6 },
        "minecraft:quartz_ore": { item: "minecraft:quartz" }
    };

    let blockTypeId = brokenBlockPermutation?.type?.id;
    let location = block?.location;

    if (blockTypeId in blockDrops) {
        let { item, min, max } = blockDrops[blockTypeId];
        let amount = (min !== undefined && max !== undefined)
            ? Math.floor(Math.random() * (max - min + 1)) + min
            : 1;
        let itemStack = new ItemStack(item, amount);
        player.dimension.spawnItem(itemStack, location);
    }
})

world.beforeEvents.playerBreakBlock.subscribe(async e => {
    let block = e.block
    let player = e.player
    let item = e.itemStack

const oreMap = {
    "minecraft:raw_iron": "minecraft:iron_ingot",
    "minecraft:raw_copper": "minecraft:copper_ingot",
    "minecraft:raw_gold": "minecraft:gold_ingot",
}
    //world.sendMessage(block.typeId)
    if (player.hasTag("arena:pickaxe_heater_gauntlet") && block.typeId.includes('ore') && item.typeId.includes('pickaxe')) {
        await null;
        let blockLocation = block.location
        let oreEntities = block.dimension.getEntities({ type: "minecraft:item", maxDistance: 2, location: block.location })

        oreEntities.forEach(oreEntity => {
            let oreItem = oreEntity?.getComponent('item').itemStack

            if (!oreMap[oreItem.typeId]) {
                return
            }
            oreEntity.remove()
            let moltenOre = new ItemStack(oreMap[oreItem.typeId])
            player.dimension.spawnItem(moltenOre, blockLocation)
            //world.sendMessage(blockId)
            })
        }

})

function giveEffect(player, tags, entity) {
    let effects = {};
    let effectTimes = {}; // Almacenar tiempos de cada efecto

    for (const [tag, effectList] of Object.entries(tags)) {
        if (!player.hasTag(tag)) continue;

        effectList.forEach(({ effect, condition, level, effectTime }) => {
            if (condition) {
                // Suma niveles correctamente y actualiza tiempos
                effects[effect] = (effects[effect] || 0) + level; // Suma niveles directamente
                effectTimes[effect] = Math.max(effectTimes[effect] || 0, effectTime);
            }
        });
    }

    // Manejo de efectos en conflicto
    const conflictingEffects = [
        { effect1: 'poison', effect2: 'regeneration' },
        { effect1: 'weakness', effect2: 'strength' },
        { effect1: 'mining_fatigue', effect2: 'haste' },
        { effect1: 'slowness', effect2: 'speed' }
    ];

    conflictingEffects.forEach(({ effect1, effect2 }) => {
        const level1 = effects[effect1] || 0;
        const level2 = effects[effect2] || 0;

        if (level1 > 0 && level2 > 0) {
            if (level1 === level2) {
                // Si los niveles son iguales, ambos se cancelan
                delete effects[effect1];
                delete effects[effect2];
                delete effectTimes[effect1];
                delete effectTimes[effect2];
            } else {
                // Mantiene el efecto más fuerte
                const strongerEffect = level1 > level2 ? effect1 : effect2;
                const weakerEffect = level1 > level2 ? effect2 : effect1;
                effects[strongerEffect] = Math.abs(level1 - level2);
                delete effects[weakerEffect];
                delete effectTimes[weakerEffect];
            }
        }
    });

    // Aplica los efectos al jugador con los tiempos correctos
    for (const [effectName, level] of Object.entries(effects)) {
        const time = effectTimes[effectName] || 0; // Tiempo correspondiente
        entity.addEffect(effectName, time, { amplifier: level - 1, showParticles: false }); // Amplificador comienza en 0
    }
}